@RestResource(urlMapping='/oss/callback')
global with sharing class OssCallbackResource{
    @HttpPost
    global static void callback() {
        OssCallback ossCallback = (OssCallback)JSON.deserialize(RestContext.request.requestbody.tostring(),OssCallback.class);
        System.debug('Received callback: ' + RestContext.request.requestbody.tostring());

        if(ossCallback.name.equals('PACKAGE_COMPLETE')){
            downloadSignedDocuments(ossCallback);
        }   
    }
    
    
    public class OssCallback
    {
        public String name;
        public String packageId;
        public String sessionUser;
        public String documentId;
        public String message;

        public OssCallback(){}
    }
    
    private static void downloadSignedDocuments(OssCallback ossCallback){
        OneSpanSDK sdk= new OneSpanSDK();
        OneSpanAPIObjects.Package_x pack = sdk.getPackage(ossCallback.packageId);

        List<Document> docs = new List<Document>();
        Folder folder = [select id from Folder where name='onespan' LIMIT 1]; 
                        
        for(OneSpanAPIObjects.Document document: pack.documents){
            Blob response = sdk.downloadDocument(ossCallback.packageId, document.id);
                            
            Document doc = new Document();
            doc.Body = response;
            doc.FolderId = folder.id;
            doc.Name = pack.name + ' - ' + document.name;
            doc.Type = 'pdf';
            docs.add(doc);
        }
                                   
        //download evidence summary
        String auditString= sdk.getAudit(ossCallback.packageId);
        Document auditDoc= new Document();
        auditDoc.Body = EncodingUtil.base64Decode(auditString);
        auditDoc.FolderId = folder.id;
        auditDoc.Name = pack.name + ' - evidence summary';
        auditDoc.Type = 'pdf';
                        
        for(Document doc: docs){
            insert doc;
            System.debug('Successfully download file: ' + doc.Name);
        }
        insert auditDoc;   

    }
    
}